#pragma once;


// RetsudenEditor.cpp : C vWFNg t@CłB
#include <windows.h>
#include <string>

// }[VOpwb_
#include <msclr/marshal_cppstd.h>
#include "ls11_mod.h"

using namespace msclr::interop;

using namespace System;
using namespace System::Drawing;
using namespace System::Collections::Generic;
using namespace System::Windows::Forms;


ref class LS11ArchieverForm : public Form {

protected:
	Label^ lvlInputFile;		// "̓t@C"Ƃ񃉃x
	TextBox^ tbInputFile;		// ̓t@Cp̃eLXg{bNX
	Button^ btnInputDialog;		// _CAOĂяop̃{^
	GroupBox^ gbProcessType;	// k𓚂̃O[vg
	RadioButton^ rbCompress;	// WI{^Bkp
	RadioButton^ rbDecompress;	// WI{^B𓀗p
	Button^ btnExecute;			// s{^

	OpenFileDialog^ ofdForCompress;  	// kp̃_CAO
	OpenFileDialog^ ofdForDeCompress;	// 𓀗p̃_CAO

	// NɃfBNg
	String^ objCurDirName;

	// R}hC
	String^ objCmdLine;

public:
	LS11ArchieverForm() {

		// N̏ێ
		SaveLaunchInfomation();

		// CAEg`~
		this->SuspendLayout();

		// tH[vpeBݒ
		SetFormProperty();

		// GUI̔zu
		AddGUIComponents();

		// GUÎCxgnĥɕRt
		SetEventHandler();

		// CAEg`ĊJ
		this->ResumeLayout();
	}

protected:

	// N̏ێ
	void SaveLaunchInfomation() {

		// ̋LqƖOԓŖՓ˂ĂĎזɂȂ邽ߒ`̏
#undef GetCurrentDirectory

		// NɃJgfBNgۑĂB
		objCurDirName = System::IO::Directory::GetCurrentDirectory();

		//R}hCzŎ擾
		cli::array<String^>^ cmds = System::Environment::GetCommandLineArgs();

		// ɉȂ
		if ( cmds->Length > 1 ) {
			objCmdLine = cmds[1];
		}
	}

	void SetFormProperty() {
		this->Text = "LS11 Archiever";

		// g̑傫
		this->Width = 280;
		this->Height = 140;

		// \[XAZu烊\[X}l[WCX^X擾
		System::Reflection::Assembly^ asmbly = System::Reflection::Assembly::GetExecutingAssembly();
		System::Resources::ResourceManager^ rm = gcnew System::Resources::ResourceManager(String::Format("{0}.LS11ArchieverRes", asmbly->GetName()->Name), asmbly);

		this->Icon = (System::Drawing::Icon^)rm->GetObject("FormICO");


		 // TCYs\
		this->FormBorderStyle = ::FormBorderStyle::FixedSingle;


	}

	void AddGUIComponents() {

		// "̓t@C"Ƃ񃉃x
		lvlInputFile = gcnew Label();
		lvlInputFile->Text = "̓t@C";
		lvlInputFile->TextAlign = ContentAlignment::MiddleCenter;
		lvlInputFile->Width = 80;
		lvlInputFile->Height = 20;
		lvlInputFile->Left = 10;
		lvlInputFile->Top  = 15;

		// ̓t@Cp̃eLXg{bNX
		tbInputFile = gcnew TextBox();
		tbInputFile->Width = 150;
		tbInputFile->Height = 20;
		tbInputFile->Left = lvlInputFile->Left + lvlInputFile->Width;
		tbInputFile->Top  = 15;
		tbInputFile->AllowDrop = true; // hbOhbv\

		// R}hC(͋NÕAvɒڃt@ChbNjB
		if ( objCmdLine ) {
			tbInputFile->Text = objCmdLine;
		}


		// _CAOĂяop̃{^
		btnInputDialog = gcnew Button();
		btnInputDialog->Text = "...";
		btnInputDialog->Left = tbInputFile->Left + tbInputFile->Width;
		btnInputDialog->Top  = 15;
		btnInputDialog->Width  = 20;
		btnInputDialog->Height = 20;

		// k𓚂̃O[vg
		gbProcessType = gcnew GroupBox();
		gbProcessType->Top = 50;
		gbProcessType->Left = 90;
		gbProcessType->Width = tbInputFile->Width + btnInputDialog->Width;
		gbProcessType->Height = 50;
		gbProcessType->Text = "";

		// k̃WI{^
		rbCompress = gcnew RadioButton();
		rbCompress->Text = "k";
		rbCompress->Width = 60;
		rbCompress->Left = 25;
		rbCompress->Top = 15;

		// 𓀂̃WI{^
		rbDecompress = gcnew RadioButton();
		rbDecompress->Text = "";
		rbDecompress->Width = 60;
		rbDecompress->Left = 100;
		rbDecompress->Top = 15;
		rbDecompress->Checked = true;

		// O[vɔzu
		gbProcessType->Controls->Add(rbCompress);
		gbProcessType->Controls->Add(rbDecompress);

		// s{^
		btnExecute = gcnew Button();
		btnExecute->Text = "s";
		btnExecute->Top = gbProcessType->Top + 15;
		btnExecute->Left = lvlInputFile->Left;
		btnExecute->Width = 70;

		// tH[ɔzu
		this->Controls->Add(lvlInputFile);
		this->Controls->Add(tbInputFile);
		this->Controls->Add(btnInputDialog);
		this->Controls->Add(gbProcessType);
		this->Controls->Add(btnExecute);
	}

	void SetEventHandler() {
		btnInputDialog->Click += gcnew EventHandler( this, &LS11ArchieverForm::btnInputDialog_Click );
		btnExecute->Click += gcnew EventHandler( this, &LS11ArchieverForm::btnExecute_Click );
		tbInputFile->DragEnter += gcnew DragEventHandler( this, &LS11ArchieverForm::tbInputFile_DragEnter );
		tbInputFile->DragDrop += gcnew DragEventHandler( this, &LS11ArchieverForm::tbInputFile_DragDrop );
	}

	void btnInputDialog_Click( Object^ sender, EventArgs^ e ) {
		// 𓀗pɃ`FbNtĂȂ΁A𓀗p̃_CAO\
		if ( rbCompress->Checked ) {
			OpenFileDialogForCompress();
		} else if ( rbDecompress->Checked ) {
			OpenFileDialogForDeCompress();
		}
	}

	void tbInputFile_DragEnter( Object^ sender, DragEventArgs^ e ) {
		//t@ChbOĂꍇAJ[\ύX
		if (e->Data->GetDataPresent(DataFormats::FileDrop)) {
			e->Effect = ::DragDropEffects::Copy;
		}
	}
	 
	void tbInputFile_DragDrop( Object^ sender, DragEventArgs^ e ) {
         //hbvꂽt@CpX܂ރt@C擾
		 cli::array<String^>^ files = (cli::array<String^>^)e->Data->GetData(DataFormats::FileDrop);
 
         //PeLXg{bNX
         tbInputFile->Text = files[0];
	}


	// pbN(Compress)ƂȂDecompressꂽt@CfBNg̐t@Cp^[Ƃđ݂邩ǂB
	bool IsExistDecompressFiles( String^ objFilePattern ) {
		// ΏۂƂȂt@C̑݃JEg
		int iExistCnt = 0;

		// pbNƂȂt@C邩ǂB
		String^ objCurFileName = "";

		// pbNƂȂt@CTB3000炢܂łŎłB
		for ( int iNo=0; iNo<3000; iNo++ ) {
			objCurFileName = String::Format( "{0}/{1}.{2:D3}", objFilePattern, objFilePattern, iNo );
			if ( System::IO::File::Exists(objCurFileName) ) {
				iExistCnt++;
			}
		}

		// ΏۂƂȂt@CB
		if ( iExistCnt ) {
			return true;
		}

		return false;
	}

	void btnExecute_Click( Object^ sender, EventArgs^ e ) {

		// ́B
		if ( tbInputFile->Text == nullptr ) {
			System::Windows::Forms::MessageBox::Show( "̓t@C͂ł", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
			return;

		// ݂BΏۂfBNgꍇɊYB
		} else if ( !System::IO::File::Exists(tbInputFile->Text) ) {
			System::Windows::Forms::MessageBox::Show( "̓t@C݂͑܂", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
			return;
		}

		// ΃pX΃pX
		tbInputFile->Text = System::IO::Path::GetFullPath(tbInputFile->Text);

		// 牺́ut@CvƂĂƑ݂B
		// t@C𒊏oB
		String^ objFilePattern = System::IO::Path::GetFileNameWithoutExtension( tbInputFile->Text );

		// ړĨt@CfBNgւƈړ
		String^ objAimDirName = System::IO::Path::GetDirectoryName( tbInputFile->Text );
		System::IO::Directory::SetCurrentDirectory( objAimDirName );

		// .NET^CvStringC++^Cvstd::string
		std::string strFullPathName = marshal_as<std::string>(tbInputFile->Text);
		std::string strFilePattern = marshal_as<std::string>(objFilePattern);


		// kpɃ`FbNtĂȂ΁Akp̃_CAO\
		int result = 0;

		if ( rbCompress->Checked ) {

			if ( IsExistDecompressFiles( objFilePattern ) ) {
				// t@CɈk
				result = ls11_EncodePack((char *)strFullPathName.c_str(), (char *)strFilePattern.c_str(), NULL );

			} else {
				result = -3;
			}

		// 𓀗pȂ΁c

		} else if ( rbDecompress->Checked ) {

			//t@CJ
			System::IO::FileStream^ fs = gcnew System::IO::FileStream( tbInputFile->Text, System::IO::FileMode::Open, System::IO::FileAccess::Read);
			//t@CǂݍރoCg^z쐬
			cli::array<byte>^ bs = gcnew cli::array<byte>(4);
			//t@C̓e4oCgǂݍ
			fs->Read(bs, 0, 4);
			//
			fs->Close();

			if ( bs[0] == 'L' && bs[1] == 'S' && bs[2] == '1' && bs[3] == '1' ) {

				// t@Cɕ
				result = ls11_DecodePack((char *)strFullPathName.c_str(), (char *)strFilePattern.c_str(), NULL );
			} else {
				result = -2;
			}
		}

		// ʂɂăbZ[W
		ShowResultMessageDialog(result);

		// JgfBNgւƖ߂B
		System::IO::Directory::SetCurrentDirectory( objAimDirName );
	}

	// ʂɂăbZ[W
	void ShowResultMessageDialog(int result ) {
		// ȂOԂĂB
		if ( result == 0) {
			System::Windows::Forms::MessageBox::Show( "܂B", "", ::MessageBoxButtons::OK, ::MessageBoxIcon::Information);
		} else if ( result == -2 ) {
			System::Windows::Forms::MessageBox::Show( "LS11`̃t@Cł͂܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
		} else if ( result == -3 ) {
			System::Windows::Forms::MessageBox::Show( "k̃t@CւƊi[邽߂\nt@CQ݂܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
		} else {
			System::Windows::Forms::MessageBox::Show( "\ʃG[܂B", "G[", MessageBoxButtons::OK, ::MessageBoxIcon::Error);
		}
	}

	// 𓀗p̃_CAO\
	void OpenFileDialogForDeCompress() {
		ofdForDeCompress = gcnew OpenFileDialog();

		ofdForDeCompress->InitialDirectory = "."; // c[ƓfBNgftHg

		ofdForDeCompress->Filter = "VċLLS11kt@C(*.nb6;*.n6p)|*.nb6;*.n6p";

		ofdForDeCompress->FilterIndex = 1;

		ofdForDeCompress->Title = "𓀌̃t@CIĂ";

		//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
		ofdForDeCompress->RestoreDirectory = true;

		//PI
		ofdForDeCompress->Multiselect = false;

		//_CAO\
		if (ofdForDeCompress->ShowDialog() == ::DialogResult::OK) {
			//OK{^NbNꂽƂ
			if ( ofdForDeCompress->FileName ) {
				tbInputFile->Text = gcnew String(ofdForDeCompress->FileName); // t@CRs[
			}
		}
	}


	void OpenFileDialogForCompress() {
		ofdForCompress = gcnew OpenFileDialog();

		ofdForCompress->InitialDirectory = "."; // c[ƓfBNgftHg

		ofdForCompress->Filter = "VċLLS11kt@C(*.nb6;*.n6p)|*.nb6;*.n6p";

		ofdForCompress->FilterIndex = 1;

		ofdForCompress->Title = "k恚̃t@CIĂ";

		//_CAO{bNXOɌ݂̃fBNg𕜌悤ɂ
		ofdForCompress->RestoreDirectory = true;

		//PI
		ofdForCompress->Multiselect = false;

		//_CAO\
		if (ofdForCompress->ShowDialog() == ::DialogResult::OK) {
			//OK{^NbNꂽƂ
			if ( ofdForCompress->FileName ) {
				tbInputFile->Text = gcnew String(ofdForCompress->FileName); // t@CRs[
			}
		}

	}

};

